
#event_handler("evntChrPerkDelay","procChrPerkDelay");
//#include "interface\perks\perks_init.c"; //Added by Levis, There is only 1 perks init file so we can just use include can't we?
//Levis: To be safe reversed this how it used to be, should help with memory management as well.
#define DEBUG_PERKS			1	//(int) on 0 no messages are given. on 1 only error, on 2 simple info is given, on 3 all info is given.

#define 	PERK_TYPE_COMBAT		"Combat"
#define 	PERK_TYPE_SAILING		"Sailing"
#define 	PERK_TYPE_SEACOMBAT		"Sea Combat"
#define 	PERK_TYPE_SEADEFENCE	"Sea Defence"
#define 	PERK_TYPE_BOARDING		"Boarding"
#define 	PERK_TYPE_MERCHANT		"Merchant"
#define 	PERK_TYPE_DARING		"Daring"
#define 	PERK_TYPE_PARTY			"Party"
#define 	PERK_TYPE_REPAIR		"Repair"
#define 	PERK_TYPE_MISC			"Misc"
#define 	PERK_TYPE_SPECIAL		"Special"

object ChrPerksList;
object PerkTypes;
object UnHidePerks;

extern void extrnInitPerks();

void InitPerks()
{
	//Clean the objects first
	DeleteAttribute(&ChrPerksList,"");
	DeleteAttribute(&PerkTypes,"");
	if( LoadSegment("Characters\perks\perks_init.c") )
	{
		extrnInitPerks();
		UnloadSegment("Characters\perks\perks_init.c");
	}
	InitPerkTypes();
}

void InitPerkTypes()
{
	//Here we set which abilities govern the perktype the most.
	//The numbers behind it show the importance of the skills
	//The total sum for the perk type should be 10
	string type = PERK_TYPE_COMBAT;
	PerkTypes.(type).Skill.Fencing = 4;
	PerkTypes.(type).Skill.Grappling = 2;
	PerkTypes.(type).Skill.Accuracy = 3;
	PerkTypes.(type).Skill.Defence = 1;
	
	type = PERK_TYPE_SAILING;
	PerkTypes.(type).Skill.Sailing = 10;
	
	type = PERK_TYPE_SEACOMBAT;
	PerkTypes.(type).Skill.Sailing = 2;
	PerkTypes.(type).Skill.Cannons = 4;
	PerkTypes.(type).Skill.Accuracy = 2;
	PerkTypes.(type).Skill.Defence = 2;
	
	type = PERK_TYPE_SEADEFENCE;
	PerkTypes.(type).Skill.Sailing = 1;
	PerkTypes.(type).Skill.Repair = 3;
	PerkTypes.(type).Skill.Defence = 6;
	
	type = PERK_TYPE_BOARDING;
	PerkTypes.(type).Skill.Grappling = 8;
	PerkTypes.(type).Skill.Fencing = 2;
	
	type = PERK_TYPE_MERCHANT;
	PerkTypes.(type).Skill.Commerce = 8;
	PerkTypes.(type).Skill.Sneak = 2;
	
	type = PERK_TYPE_DARING;
	PerkTypes.(type).Skill.Sneak = 6;
	PerkTypes.(type).Skill.Commerce = 2;
	PerkTypes.(type).Skill.Fencing = 2;
	
	type = PERK_TYPE_PARTY;
	PerkTypes.(type).Skill.Leadership = 3;
	PerkTypes.(type).Skill.Defence = 5;
	PerkTypes.(type).Skill.Sneak = 2;
	
	type = PERK_TYPE_REPAIR;
	PerkTypes.(type).Skill.Repair = 7;
	PerkTypes.(type).Skill.Defence = 3;
	
	type = PERK_TYPE_MISC;
	PerkTypes.(type).Skill.Leadership = 10;

	//Add all the perks to the types to for easy lookup
	aref perklist, condition; 
	makearef(perklist, ChrPerksList.list);
	int num = GetAttributesNum(perklist);
	int condnum = 0;
	string perkname, perktype, perkname2;
	for(int n = 0; n < num; n++)
	{
		perkname = GetAttributeName(GetAttributeN(perklist, n));
		if(!CheckAttribute(perklist,perkname+".type"))
		{
			TraceAndLog("PERK ERROR: perk "+perkname+" doesn't have a type. Please post your compile.log file at piratesahoy.net!");
			//DeleteAttribute(perklist,perkname); //remove it cause it's probably useless and else people will at least notice better
			num -= 1;
			continue;
		}
		perktype = perklist.(perkname).type;
		PerkTypes.(perktype).Perks.(perkname) = perklist.(perkname).cost;
		if(CheckAttribute(perklist,perkname+".rank")) PerkTypes.(perktype).Perks.(perkname).rank = perklist.(perkname).rank;
		//Check if the perk unlocks another perk because that is better
		for(int i = 0; i < num; i++)
		{
			perkname2 = GetAttributeName(GetAttributeN(perklist, i));
			if(!CheckAttribute(perklist,perkname2+".type"))
			{
				trace("PERK ERROR: perk "+perkname2+" doesn't have a type");
				continue;
			}
			if(perktype == perklist.(perkname2).type)
			{
				if(CheckAttribute(perklist,perkname2+".condition"))
				{
					makearef(condition,perklist.(perkname2).condition);
					condnum = GetAttributesNum(condition);
					for(int j = 0; j < condnum; j++)
					{
						if(perkname == GetAttributeName(GetAttributeN(condition, j))) PerkTypes.(perktype).Perks.(perkname).unlocks = true;
					}
				}
			}
		}
	}
}

//Levis: Special perks -->
bool PerkIsSpecial(string perkName)
{
	if(CheckAttribute(ChrPerksList,"list."+perkName+".type"))
	{
		if(ChrPerksList.list.(perkName).type == PERK_TYPE_SPECIAL) return true;
	}
	else
	{
		if(DEBUG_PERKS>0) Trace("PERKS ERROR: perk "+perkName+" is missing a type");
	}
	return false;
}
//Levis: Special perks <--

//Levis: Hidden perk -->
bool CheckPerkHidden(ref Character, string perkName)
{
	//Check if the perk is hidden
	if(CheckAttribute(ChrPerksList,"list."+perkName+".hidden"))
	{
		//If it's hidden check if there are any unhide scenarios
		if(CheckAttribute(UnHidePerks,"list."+perkName))
		{
			//The perk can be unhidden so check if this character has the right attributes
			aref Perk, ID; 
			int  numid, numval, j, k;
			string attribute_name, attribute_value;
			//Get the perk information
			makearef(Perk,UnHidePerks.list.(perkName));
			//Now let's check which attributes are set. These need to be checked at the character
			numid = GetAttributesNum(Perk);
			for(j=0; j<numid; j++)
			{
				//Get the specific ID of the unhide condition
				ID = GetAttributeN(Perk,j);
				attribute_name = GetAttributeValue(ID);
				//A attribute can have more then 1 value which can be true to unhide the perk. So we need to check the values to see which we need to check.
				//But first check if this character has the attribute at all.
				if(CheckAttribute(character,attribute_name))
				{
					numval = GetAttributesNum(ID);
					for(k=0; k<numval; k++)
					{
						//Check if the value is set right, else it's still hidden
						if(GetAttributeValue(GetAttributeN(ID,k)) == "unhidden")
						{
							attribute_value = GetAttributeName(GetAttributeN(ID,k));
							//Now we know the value and attribute so check it for the character
							if(GetAttribute(character,attribute_name) == attribute_value)
							{
								//the perk is unhidden
								return false;
							}
						}
					}
				}
			}
		}
		//The perk is hidden so we return true
		return true
	}
	return false;
}

void ResetHidePerks(string attribute)
{
	//This function will remove a certain attribute from the UnHidePerks list so it can be set again in a (re)init.
	aref Perks, Perk; 
	int numid, i, j;
	string ID_val;
	makearef(Perks,UnHidePerks.list);
	int num = GetAttributesNum(Perks);
	
	for(i=0; i<num; i++)
	{
		Perk = GetAttributeN(Perks,i);
		numid = GetAttributesNum(Perk);
		for(j=0; j<numid; j++)
		{
			ID_val = GetAttributeValue(GetAttributeN(Perk,j));
			trace(attribute+" == "+ID_val);
			if(attribute == ID_val)
			{
				DeleteAttribute(&Perk,GetAttributeName(GetAttributeN(Perk,j)));
			}
		}
	}
}

void UnHidePerk(string perkName, string attribute, string value)
{
	//This function unhides a perk if a character has a certain [attribute] set to a specific [value]
	//The UnHidePerks object has a list attribute in where all the different attributes and values are stored for the givven perkname.
	//The attribute can be multiple levels deep so we need to make sure it's stored as a string. So we want to get an ID for the attribute
	string baseID = "attr_";
	int attnum = 0;
	string ID = baseID+attnum;
	while(CheckAttribute(UnHidePerks,"list."+perkName+"."+ID))
	{
		attnum++;
		ID = baseID+attnum;
	}
	UnHidePerks.list.(perkName).(ID) = attribute
	UnHidePerks.list.(perkName).(ID).(value) = "unhidden";
}
//Levis: Hidden perk <--

bool CheckPerkAvailable(string perkName)
{
	//Levis Disable perks -->
	if(CheckAttribute(ChrPerksList,"list."+perkName+".disable"))
	{
		int i, dn;
		aref arCur, arDis;
		string needName;
		makearef(arDis,ChrPerksList.list.(perkName).disable);
		dn = GetAttributesNum(arDis);
		
		for(i=0; i<dn; i++)
		{
			arCur = GetAttributeN(arDis,i);
			needName = GetAttributeName(arCur);
			switch(needName)
			{
				case "iRealismMode":
					if(REALISTIC_ABILITIES == 1 && iRealismMode>=sti(GetAttributeValue(arCur)))		{ return false; } // PB: To allow REALISTIC_ABILITIES to override the Realism Mode
				break;
				
				case "REALISTIC_ABILITIES":
					if(REALISTIC_ABILITIES == 1 && iRealismMode == 0)								{ return true;  } // PB: To ensure Arcade Game Mode does override the Build Default
					if(REALISTIC_ABILITIES >= sti(GetAttributeValue(arCur)))						{ return false; }
				break;
				
				case "StorylineVar":
					if(sti(GetStorylineVar(FindCurrentStoryline(), GetAttributeValue(arCur))) < 1)	{ return false; }
				break;
			}
		}
	}
	//Levis Disable perks <--
	return true;
}

//Levis Check rank
bool CheckPerkRank(ref character, string perkName)
{
	if( CheckAttribute(ChrPerksList,"list."+perkName + ".rank"))
	{
		if( CheckAttribute(character,"rank"))
		{
			int Playerrank = makeint(character.rank);
			int Perkrank = makeint(ChrPerksList.list.(perkName).rank);
			if(Playerrank >= Perkrank)
			{
				return true;
			}
		}
		return false;
	}
	return true;
}

int GetPerkRank(string perkName)
{
	if( CheckAttribute(ChrPerksList,"list."+perkName + ".rank"))
	{
		int Perkrank = makeint(ChrPerksList.list.(perkName).rank);
		return Perkrank;
	}
	return 0;
}

//Check perk conditions
bool CheckPerkConditions(ref refUsedCharacter, string PerkName)
{
	aref perkARef; 
	makearef(perkARef, ChrPerksList.list.(PerkName).condition);
	string abilName;
	bool canassign = true;
	for(int i = 0; i < GetAttributesNum(perkARef); i++)
	{
		abilName = GetAttributeName(GetAttributeN(perkARef,i));
		if(!CheckPerkSimple(refUsedCharacter, abilName))
		{
			canassign = false;
		}
	}
	return canassign;
}

//Levis Locked Perks -->
bool CheckCharacterPerkLocked(ref Character, string perkName)
{
	if(PerkHasLock(Character, perkName))
	{
		if(!CheckAttribute(Character,"unlocked_mind"))
		{
			if( CheckAttribute(Character,"perks.unlocked."+perkName))
			{
				return false;
			}
			if(IsOfficerCompanion(Character))
			{
				ref captain = GetCharacter(FindCaptainIndex(Character));
				return CheckCharacterPerkLocked(captain, perkName)
			}
			if(IsPassenger(character) && !IsMainCharacter(character))
			{
				//If the main character has the perk unlocked then all officers will have it unlocked to. not the other way around tough.
				return CheckCharacterPerkLocked(GetMainCharacter(), perkName);
			}
			if(IsCompanion(character)&& !IsMainCharacter(character))
			{
				//If the main character has the perk unlocked then all officers will have it unlocked to. not the other way around tough.
				return CheckCharacterPerkLocked(GetMainCharacter(), perkName);
			}
			if(!IsMainCharacter(character))
			{
				//This is a random Character so return what the mainCharacter has for locked perks.
				return CheckCharacterPerkLocked(GetMainCharacter(), perkName);
			}
			return true;
		}
	}
	return false;
}

bool PerkHasLock(ref Character, string perkName)
{
	//Checks if the perk has a lock
	if(ALLOW_LOCKED_PERKS)
	{
		if( CheckAttribute(ChrPerksList,"list."+perkName + ".locked"))
		{
			return true;
		}
		if( CheckAttribute(Character,"perks.locked."+perkName))
		{
			return true;
		}
	}
	return false;
}

bool UnlockPerkCharacter(ref Character, string perkName)
{
	if(!CheckAttribute(Character,"perks.unlocked."+perkName))
	{
		if(PerkHasLock(Character, perkName)) //Levis only unlock if there is a lock in place
		{
			//Only show notification if player is main character
			if(IsMainCharacter(Character) && GetAttribute(Character, "location") != "Tutorial_Deck") // PB: Skip sound here
			{
				int lngFileID = LanguageOpenFile("AbilityDescribe.txt");
				string Text = LanguageConvertString(lngFileID,"Unlocked");
				string Name = LanguageConvertString(lngFileID,perkName);
				PlaySound("INTERFACE\notebook.wav");
				Logit(Text + " " + Name);
				LanguageCloseFile(lngFileID);
			}
			DeleteAttribute(Character,"perks.locked."+perkName);
			Character.perks.unlocked.(perkName) = true;
			return true;
		}
	}
	return false;
}

void LockPerk(ref Character, string perkName)
{
	Character.perks.locked.(perkName) = true;
}
// <--Levis Locked Perks

void ActivateCharacterPerk(ref chref, string perkName)
{
	if( !CheckAttribute(&ChrPerksList,"list."+perkName) )
	{
		trace("Invalid perk name - " + perkName);
		return;
	}

	int timeDelay = 0;
	int timeDuration = 0;

	if( CheckAttribute(&ChrPerksList,"list."+perkName+".TimeDuration") )
	{	timeDelay = sti(ChrPerksList.list.(perkName).TimeDuration);
		timeDuration = timeDelay;
	}
	if( CheckAttribute(&ChrPerksList,"list."+perkName+".TimeDelay") )
	{	timeDelay = sti(ChrPerksList.list.(perkName).TimeDelay);
		if(timeDuration<=0)	{timeDuration=timeDelay;}
	}

	chref.perks.list.(perkName).delay = timeDelay;
	chref.perks.list.(perkName).active = timeDuration;

	if(sti(chref.index)==GetMainCharacterIndex())
	{
		AddPerkToActiveList(perkName);
	}

	if(timeDelay>0) PostEvent("evntChrPerkDelay",1000,"sl",perkName,sti(chref.index));
	Event("eSwitchPerks","l",sti(chref.index));
}

bool IsCharacterPerkOn(ref chref, string perkName)
{
	aref arRoot, arBase;
	makearef(arRoot,chref.perks.list);
	if( !CheckAttribute(arRoot,perkName) ) return false;
	makearef(arBase,ChrPerksList.list.(perkName));
	if( CheckAttribute(arBase,"TimeDuration") || CheckAttribute(arBase,"TimeDelay") ) {
		return CheckAttribute(arRoot,perkName+".active");
	}
	return true;
}

void CharacterPerkOff(ref chref, string perkName)
{
	DeleteAttribute(chref,"perks.list."+perkName+".active");
	Event("eSwitchPerks","l",sti(chref.index));
	if(sti(chref.index)==GetMainCharacterIndex())
	{
		DelPerkFromActiveList(perkName);
	}
}

void procChrPerkDelay()
{
	string perkName = GetEventData();
	int chrIdx = GetEventData();

	aref arPerk;
	makearef(arPerk,Characters[chrIdx].perks.list.(perkName));
	if( !CheckAttribute(arPerk,"delay") ) return;
	int delay = sti(arPerk.delay);
	delay--;

	if( CheckAttribute(arPerk,"active") )
	{
		int iActive = sti(arPerk.active)-1;
		if( iActive>0 )	{arPerk.active = iActive;}
		else
		{
			CharacterPerkOff(GetCharacter(chrIdx),perkName);
		}
	}

	if( delay<=0 )
	{	DeleteAttribute(&Characters[chrIdx],"perks.list."+perkName+".delay");
		DeleteAttribute(&Characters[chrIdx],"perks.list."+perkName+".active");
		PostEvent("evntPerkAgainUsable",1);
	}
	else
	{
		Characters[chrIdx].perks.list.(perkName).delay = delay;
		PostEvent("evntChrPerkDelay",1000,"sl",perkName,chrIdx);
	}
}

void EnableUsingAbility(ref chref,string perkName)
{
	Event("evntChrPerkDelay","sl",perkName,sti(chref.index));
}

void PerkLoad()
{
//	int iRDTSC = RDTSC_B();

	ref mainCh = GetMainCharacter();
	string locName = mainCh.location;
	aref arPerksRoot,arPerk;
	int i,j,n,tmpi;

	//TODO: Use loaded locations instead
	for(i=0; i<CHARACTERS_QUANTITY; i++) // NK 05-04-05 use CHARACTERS_QUANTITY. This is weird, though, it doesn't count fantoms.
	{
		if(Characters[i].location == locName)
		{
			makearef(arPerksRoot,Characters[i].perks.list);
			n = GetAttributesNum(arPerksRoot);
			for(j=0; j<n; j++)
			{
				arPerk = GetAttributeN(arPerksRoot,j);
				if( CheckAttribute(arPerk,"delay") )
				{
					tmpi = sti(arPerk.delay);
					if( tmpi>0 )
					{
						PostEvent("evntChrPerkDelay",1000,"sl",GetAttributeName(arPerk),i);
					}
				}
			}
		}
	}

//	trace("TIME!!! PerkLoad() = " + RDTSC_E(iRDTSC));
}

void ClearActiveChrPerks(ref chref)
{
	aref arPerksRoot, arPerk;
	int i,n,j,cn;

	for (j = 0; j < OFFICER_MAX; j++)
	{
		cn = GetOfficersIndex(chref,j);
		if( cn<0 ) {continue;}
		makearef( arPerksRoot, Characters[cn].perks.list );
		n = GetAttributesNum(arPerksRoot);
		for (i = 0; i < n; i++)
		{
			arPerk = GetAttributeN(arPerksRoot,i);
			if (CheckAttribute(arPerk,"delay"))		DeleteAttribute(arPerk,"delay");
			if (CheckAttribute(arPerk,"active"))	DeleteAttribute(arPerk,"active");
		}
	}
}

bool isPerkAssignable(ref character, string perkName, int freePoints)
{
	if(DEBUG_PERKS>1) Trace("PERKS: call isPerkAssignable");
	//Locked Perks
	if(CheckCharacterPerkLocked(character, perkName)) return false;
	if(DEBUG_PERKS>2) Trace("PERKS: Perk is not locked");
	//Check other stuff
	if(!isPerkAssignableNoLock(character, perkName, freePoints)) return false;
	return true;
}

bool isPerkAssignableNoLock(ref character, string perkName, int freePoints)
{
	if(DEBUG_PERKS>1) Trace("PERKS: call isPerkAssignableNoLock");
	//Check if it's fit for this type of officer
	if(!isOfficerPerk(character, perkName)) return false; 
	if(DEBUG_PERKS>2) Trace("PERKS: Perk is the right officertype");
	//Check other stuff
	if(!isPerkAssignableOfficer(character, perkName, freePoints)) return false;
	return true;
}

bool isPerkAssignableOfficer(ref character, string perkName, int freePoints)
{
	if(DEBUG_PERKS>1) Trace("PERKS: call isPerkAssignableOfficer");
	//Check if perk is already chosen
	if(CheckPerkSimple(character, perkName)) return false;
	if(DEBUG_PERKS>2) Trace("PERKS: Character doesn't have perk yet");
	//Check free points
	if(freePoints < GetPerkCost(perkName)) return false;
	if(DEBUG_PERKS>2) Trace("PERKS: Character has enough points");
	//Check if avaible
	if(!CheckPerkAvailable(perkname)) return false;
	if(DEBUG_PERKS>2) Trace("PERKS: Perk is avaible");
	//Check Rank
	if(!CheckPerkRank(character, perkName)) return false;
	if(DEBUG_PERKS>2) Trace("PERKS: Character has the right rank");
	//Check Conditions
	if(!CheckPerkConditions(character, PerkName)) return false;
	if(DEBUG_PERKS>2) Trace("PERKS: Conditions for the perk are met");
	//Check Hidden
	if(CheckPerkHidden(character, PerkName)) return false;
	if(DEBUG_PERKS>2) Trace("PERKS: Perk is not hidden");
	return true;
}

bool isPerkExisting(string perkName)
{
	return CheckAttribute(&ChrPerksList, "list." + perkName);
}

// Aconcagua: moved to here
//Levis show only officer perks
bool isOfficerPerk(ref character, string perkName)
{
	if(DEBUG_PERKS>1) Trace("PERKS: called isOfficerPerk for character "+character.id+" and perkname "+perkName);
	if(IsMainCharacter(character)) return true; //Main Character has all perks
	if(DEBUG_PERKS>2) Trace("PERKS: character is not maincharacter");
	//Check if perk is a combat perk, if so return true
	if(CheckAttribute(OfficerTypes,"Combat.perks."+perkName)) return true;
	if(DEBUG_PERKS>2) Trace("PERKS: perk is not a combat type");
	//Else check if the perk is for this specific officer
	string officerType = OFFIC_TYPE_RANDCHAR;
	if(CheckAttribute(character,"quest.officertype")) officerType = character.quest.officertype;
	if(CheckAttribute(OfficerTypes,officerType+".perks."+perkName)) return true;
	if(DEBUG_PERKS>2) Trace("PERKS: perk is not for this officertype "+officerType);
	//If officer has unlocked his mind
	if(CheckAttribute(Character,"unlocked_mind"))
	{
		if(CheckAttribute(OfficerTypes,"SuperOfficer.perks."+perkName)) return true;
	}
	if(DEBUG_PERKS>2) Trace("PERKS: character doesn't get it because of unlocked mind");
	//Check if it's a special hidden perk
	if(!CheckPerkHidden(character, perkName)) return false;
	if(DEBUG_PERKS>2) Trace("PERKS: perk is a special hidden perk");
	//The hidden check will return false on all perks except the special ones, so for these we return true.
	return true;
}

//Check only for this character, should only be used for perk interface
bool CheckPerkForSingleCharacter(ref character, string perkName)
{
	if(DEBUG_PERKS>1) Trace("PERKS: called CheckPerkForSingleCharacter for character "+character.id+" and perkname "+perkName);
	if(isOfficerPerk(character, perkName)) //Only when the perk is in the scope of this character
	{
		if(DEBUG_PERKS>2) Trace("PERKS: perk is officerperk");
		if (CheckPerkAvailable(perkName)) //Levis disable perks
		{
			if(DEBUG_PERKS>2) Trace("PERKS: perk is avaible");
			return CheckPerkSimple(character, perkName);
		}
	}
	return false;
}

//Checks if a perk is taken or not
bool CheckPerkSimple(ref character, string perkName)
{
	if( CheckAttribute(character,"perks.list."+perkName) ) 					return true;
	if( CheckAttribute(ChrPerksList, "list." + perkName+".auto_enable") ) 	return true;
	return false;
}

bool AddPerkToCharacter(ref character, string perkName)
{
	if(DEBUG_PERKS>1) Trace("PERKS: Called AddPerkToCharacter for character "+character.id+" and perk "+perkName);
	//This function will Add a perk to given character
	if(AddPerkToCharacterSimple(character, perkName))
	{
		character.perks.FreePoints = sti(character.perks.FreePoints) - GetPerkCost(perkName);
		if(sti(character.perks.FreePoints) < 0)
		{
			character.perks.FreePoints = 0;
			if(DEBUG_PERKS>0) trace("PERKS ERROR: When adding perk "+perkName+" to character "+character.id+" the freepoints went below 0");
		}
		return true;
	}
	return false;
}

bool AddPerkToCharacterSimple(ref character, string perkName)
{
	//This function will Add a perk to given character without changing the freepoints
	if(DEBUG_PERKS>1) Trace("PERKS: Called AddPerkToCharacterSimple for character "+character.id+" and perk "+perkName);
	if(CheckAttribute(ChrPerksList, "list." + perkName))
	{
		if(!CheckPerkSimple(character, perkName))
		{
			character.perks.list.(perkName) = true;
			return true;
		}
	}
	else
	{
		if(DEBUG_PERKS>0) trace("PERKS ERROR: trying to add perk "+perkName+" to character "+character.id+" but perk doesn't exist");
	}
	return false;
}

bool RemovePerkFromCharacter(ref character, string perkName)
{
	if(DEBUG_PERKS>1) Trace("PERKS: Called RemovePerkToCharacter for character "+character.id+" and perk "+perkName);
	//This function will Add a perk to given character
	if(RemovePerkFromCharacterSimple(character, perkName))
	{
		character.perks.FreePoints = sti(character.perks.FreePoints) + GetPerkCost(perkName);
		return true;
	}
	return false;
}

bool RemovePerkFromCharacterSimple(ref character, string perkName)
{
	//This function will remove a perk from given character without changing the freepoints
	if(DEBUG_PERKS>1) Trace("PERKS: Called RemovePerkFromCharacterSimple for character "+character.id+" and perk "+perkName);
	if(CheckAttribute(ChrPerksList, "list." + perkName))
	{
		if(!CheckPerkSimple(character, perkName))
		{
			DeleteAttribute(character,"perks.list."+perkName);
			return true;
		}
	}
	else
	{
		if(DEBUG_PERKS>0) trace("PERKS ERROR: trying to add perk "+perkName+" to character "+character.id+" but perk doesn't exist");
	}
	return false;
}

void ResetCharacterPerkContrib(ref character)
{
	//This function is called on each location load to be sure everything is okay. it could be something weird happened with the perks if people remove or add them without changing the freepoints, thats why clean it up for each location.
	DeleteAttribute(character,"perks.contributers");
	DeleteAttribute(character,"perks.passengers");
	DeleteAttribute(character,"perks.contributed");
}

//Levis definitive function to check if the perk should contribute or not
bool CheckPerkForGroup(ref character, string perkName, bool contributer)
{
	if(DEBUG_PERKS>1) Trace("PERKS: Called CheckPerkForGroup for character "+character.id+" for perkname "+perkName+" and contributer is "+contributer);
	int cn, num, i;
	ref chr;
	bool val;
	//Let's try to rewrite this function because it's still flawed
	//This function is called in call cases where a perk has to be checked. It should return true if someone contributes the perk to the character or if the character has it himself.
	//If contributer if set to true this function will also take the noncontribute statements into account.
	//To save on performance we first check if we calculated this before:
	if(CheckAttribute(character,"perks.contributed."+perkName)) 
	{
		//Check if there is a contributor and if so he is still the same.
		if(CheckAttribute(character,"perks.contributers."+perkName))
		{
			cn = sti(character.perks.contributers.(perkName).chridx);
			chr = GetCharacter(cn);
			//Check if the officertype is still the same
			if(character.perks.contributers.(perkName).officertype == chr.quest.officerType)
			{
				//Check if the freepoints are still the same
				if(character.perks.contributers.(perkName).freepoints == chr.perks.FreePoints)
				{
					val = sti(character.perks.contributed.(perkName)) == 1;
					if(DEBUG_PERKS>1) Trace("PERKS: get perk from stored values");
					if(!val)
					{
						//Now we check if any officer has changed. We only have to do this if the perk wasn't assigned yet. If so we need to recheck the perks.
						num = GetPassengersQuantity(character);
						bool recheck = false;
						for(i = 0; i < num; i++)
						{
							cn = GetPassenger(character, i);
							chr = GetCharacter(cn);
							if(GetAttribute(character,"perks.passengers."+cn) != GetAttribute(chr,"perks.FreePoints"))
							{
								if(DEBUG_PERKS>1) Trace("PERKS: passenger "+chr.id+" is changed so we need to recheck the perks");
								recheck = true;
								break;
							}
						}
					}
					//If we don't need to recheck we can return the value
					if(!recheck)
					{
						return val;
					}
				}
				else
				{
					if(DEBUG_PERKS>2) Trace("PERKS: recalculate perk because freepoints is not the same");
				}
			}
			else
			{
				if(DEBUG_PERKS>2) Trace("PERKS: recalculate perk because officertype is not the same");
			}
		}
		else
		{
			if(DEBUG_PERKS>0) Trace("PERKS ERROR: perk "+perkName+" is contributed but has no contributer");
		}
	}
	
	//First we check if the character himself has the perk. If this is the case we are done quickly, unless contributer is true
	bool hasPerk = false;
	if(contributer)
	{
		//We are a contributer so we should exclude combat perks and check for noncontribute settings
		string officerType = OFFIC_TYPE_RANDCHAR;
		if(CheckAttribute(character,"quest.officertype"))
		{
			officerType = character.quest.officertype;
		}
		else
		{
			if(DEBUG_PERKS>0) Trace("PERKS ERROR: character "+character.id+" is missing an officertype");
		}
		if(!CheckAttribute(OfficerTypes,officerType+".notcontribute")) 
		{
			if(!CheckAttribute(OfficerTypes,"Combat.perks."+perkName))
			{
				hasPerk = CheckPerkForSingleCharacter(character, perkName);
			}
			else
			{
				if(DEBUG_PERKS>2) Trace("PERKS: perk is a combat type");
			}
		}
		else
		{
			if(DEBUG_PERKS>2) Trace("PERKS: character is a non-contributing type");
		}
	}
	else
	{
		//We aren't a contributer so we check normally if the character has the perk.
		hasPerk = CheckPerkForSingleCharacter(character, perkName);
	}
	
	if(DEBUG_PERKS>1) Trace("PERKS: after charactercheck hasPerk is now "+hasPerk);
	
	//Now we are going to check if this perk is contributed to this character
	if(!hasPerk)
	{
		//Now we check for all passengers (if there are any) to see if they contribute to this character
		num = GetPassengersQuantity(character);
		string passid = "";
		if(DEBUG_PERKS>1) Trace("PERKS: check for "+num+" passengers if they contribute this perk");
		for(i = 0; i < num; i++)
		{
			cn = GetPassenger(character, i);
			if(cn < 0) continue;
			chr = GetCharacter(cn);
			if(CheckAttribute(chr,"prisoned") || IsTrader(chr)) continue;
			if(DEBUG_PERKS>2) Trace("PERKS: check passenger "+i);
			//validate passenger
			if(! CheckAttribute(chr,"quest.officertype")) chr.quest.officerType = OFFIC_TYPE_RANDCHAR;
			if(! CheckAttribute(chr,"perks.freepoints")) chr.perks.freepoints = 0;
			//store the passenger
			passid = cn;
			character.perks.passengers.(passid) = chr.perks.FreePoints;
			//Check if it has the perk
			hasPerk = CheckPerkForGroup(chr, perkName, true); //We call ourself again but this time as contributer with this passenger
			if(hasPerk) 
			{
				//We store the officer who contribute this perk so we can check if he is still in the same position to contribute this
				character.perks.contributed.(perkName) = hasPerk;
				character.perks.contributers.(perkName).chridx = cn;
				character.perks.contributers.(perkName).officertype = chr.quest.officerType;
				character.perks.contributers.(perkName).freepoints = chr.perks.freepoints;
				//If one officer contributes we can break the loop, we don't need to know if the others also contribute in this case
				return hasPerk;
			}
		}
	}
	if(DEBUG_PERKS>1) Trace("PERKS: after passenger check hasPerk is now "+hasPerk);
	//Because this system could take up resource because some calls are made very often we store the value we've gotten for this character so we can check it again.
	if(!contributer)
	{
		if(CheckAttribute(character,"index"))
		{
			//As a contributer not all your perks are checked so we don't save it for you.
			character.perks.contributed.(perkName) = hasPerk;
			character.perks.contributers.(perkName).chridx = character.index;
			if(CheckAttribute(character,"quest.officertype"))
			{
				character.perks.contributers.(perkName).officertype = character.quest.officerType;
			}
			else 
			{
				character.perks.contributers.(perkName).officertype = "";
			}
			if(! CheckAttribute(character,"perks.freepoints")) character.perks.FreePoints = 0;
			character.perks.contributers.(perkName).freepoints = character.perks.FreePoints;
		}
		else
		{
			if(DEBUG_PERKS>0) trace("PERK ERROR: Character has no index");
			if(DEBUG_PERKS>0) DumpAttributes(character);
		}
	}
	return hasPerk;
}

//Levis Add perkcost-->
int GetPerkCost(string perkName)
{
	aref Perk;
	makearef(Perk,ChrPerksList.list.(perkName));
	if (CheckAttribute(Perk,"cost") && PERK_MULTIPLIER>0)
	{
		int cost = makeint(sti(Perk.cost)*PERK_MULTIPLIER);
		if(cost>0)
		{
			return cost;
		}
		else
		{
			return 1;
		}
	}
	return 1;
}
//<-- Levis Add perkcost

//
// Redirected functions:
//
bool CheckOfficersPerk(ref chref, string perkName)
{
	return CheckPerkForGroup(chref, perkName, false);
}

bool GetCharacterPerkUsing(ref chref, string perkName)
{
	return CheckPerkForGroup(chref, perkName, false); //Levis
}

bool GetOfficersPerkUsing(ref chref, string perkName)
{
	return CheckPerkForGroup(chref, perkName, false); //Levis
}

bool CheckCharacterPerk(ref chref, string perkName)
{
	return CheckPerkForGroup(chref, perkName, false); //Levis
}